T1DISASM (1)                                         T1DISASM (1)


NAME
     t1disasm - disassemble type-1 font

SYNOPSIS
     t1disasm [input[output]]

DESCRIPTION
     t1disasm dissassembles Adobe type-1 font programs in either
     PFA (hexadecimal) or PFB (binary) formats into human-read-
     able form.  If the file output is not specified output goes
     to the standard output.  If the file input is not specified
     input comes from the standard input.  In this way t1disasm
     can be used as a filter.

     t1disasm performs eexec and charstring decryption as speci-
     fied in the Adobe Type 1 Font Format, the Adobe black book.
     Additionally, the charstring binary tokens are expanded into
     human-readable text form.

EXAMPLES
     t1disasm Utopia-Regular.pfb Utopia-Regular.raw
     t1disasm Utopia-Regular.pfa Utopia-Regular.raw

     In this case, the resulting Subrs entries look like

     dup 5 {
             8 111 vstem
             -12 128 hstem
             707 -20 hstem
             return
             } |

     and the CharStrings entries like

     /exclam {
             58 242 hsbw
             6 callsubr
             5 4 callsubr
             63 707 rmoveto
             -54 0 -5 -22 4 -45 rrcurveto
             40 -431 rlineto
             29 hlineto
             42 431 rlineto
             4 45 -5 22 -55 0 rrcurveto
             closepath
             6 4 callsubr
             -719 vmoveto
             243 callsubr
             endchar
             } |-

     in Utopia-Regular.raw.

SEE ALSO
     t1asm (1), t1ascii (1), t1binary (1),
     Adobe Type 1 Font Format

BUGS
     None known.

AUTHOR
     Lee Hetherington (ilh@lcs.mit.edu)

     Ported to Microsoft C/C++ Compiler and MS-DOS operating
     system by Kai-Uwe Herbing (herbing@netmbx.netmbx.de)

                          June 12, 1992
